module(..., package.seeall)


----------------------------------------------------------------------------------------------------------
-- function: 		initBridgeMode()
-- description:		used to create bridgemode UI and init mode
-- parameter:		none
-- return:			none
----------------------------------------------------------------------------------------------------------
function initBridgeMode()
	glob.utilityMarker.bridgeMode.startPos = glob.utilityMarker.marker[1].position
	glob.utilityMarker.bridgeMode.endPos = glob.utilityMarker.marker[2].position

	game.player.gui.top.um_utilityMarkerMainMenuFrame.destroy()
	BridgeMode_UI_creation()
end

----------------------------------------------------------------------------------------------------------
-- function: 		BridgeMode_UI_creation()
-- description:		creates the bridge-mode UI
-- parameter:		none
-- return:			none
----------------------------------------------------------------------------------------------------------
function BridgeMode_UI_creation()
	bb_BridgeModeMenuFrame = game.player.gui.top.add{type="frame", name="bb_BridgeModeMenuFrame", caption="Create Bridge", direction="vertical"}
		bb_BridgeModeMenuFrame.add{type="label", name="bb_startPosLabel", caption="Startposition: " ..util.positiontostr(glob.utilityMarker.bridgeMode.startPos)}
		bb_BridgeModeMenuFrame.add{type="label", name="bb_endPosLabel", caption="Endposition: " ..util.positiontostr(glob.utilityMarker.bridgeMode.endPos)}
		bb_BridgeModeMenuFrame.add{type="checkbox", name="bb_avoidAll",caption = "Avoid Entities & Water", state = true}
		bb_BridgeModeMenuFrame.add{type="checkbox", name="bb_avoidWater",caption = "Avoid Water", state = false}
		bb_BridgeModeMenuFrame.add{type="checkbox", name="bb_avoidNothing",caption = "Avoid Nothing", state = false}
		bb_BridgeModeMenuFrame.add{type="label", name="bb_emptyLine1", caption=" "}
		bb_BridgeModeMenuFrame.add{type="button", name="bb_Calculate", caption="Calculate Path"}
		bb_BridgeModeMenuFrame.add{type="label", name="bb_emptyLine2", caption=" "}
		
		bb_BridgeModeMenuFrame.add{type="button", name="bb_cancelButton", caption="Cancel"}
end

----------------------------------------------------------------------------------------------------------
-- function: 		bbButtonClicked(buttonName)
-- description:		used to determine which bridgeMode menu button was clicked  
-- parameter:		buttonName
-- return:			none
----------------------------------------------------------------------------------------------------------
function bbButtonClicked(buttonName)
	if (buttonName == "bb_avoidAll") then
		bb_BridgeModeMenuFrame.bb_avoidWater.state =  not bb_BridgeModeMenuFrame.bb_avoidAll.state
		bb_BridgeModeMenuFrame.bb_avoidNothing.state =  not bb_BridgeModeMenuFrame.bb_avoidAll.state
	elseif (buttonName == "bb_avoidWater") then
		bb_BridgeModeMenuFrame.bb_avoidAll.state =  not bb_BridgeModeMenuFrame.bb_avoidWater.state
		bb_BridgeModeMenuFrame.bb_avoidNothing.state =  not bb_BridgeModeMenuFrame.bb_avoidWater.state
	elseif (buttonName == "bb_avoidNothing") then
		bb_BridgeModeMenuFrame.bb_avoidAll.state =  not bb_BridgeModeMenuFrame.bb_avoidNothing.state
		bb_BridgeModeMenuFrame.bb_avoidWater.state =  not bb_BridgeModeMenuFrame.bb_avoidNothing.state

	elseif buttonName =="bb_Calculate" then
		if (startcalc == false) or (startcalc == nil) then
			if bb_BridgeModeMenuFrame.bb_avoidAll.state == true then
				glob.utilityMarker.bridgeMode.mode = "avoidAll"
			elseif bb_BridgeModeMenuFrame.bb_avoidWater.state == true then
				glob.utilityMarker.bridgeMode.mode = "avoidWater"
			elseif bb_BridgeModeMenuFrame.bb_avoidNothing.state == true then
				glob.utilityMarker.bridgeMode.mode = nil
			end
			startcalc = true
		else
			game.player.print("Calculation allready in progress")
		end
	elseif buttonName == "bb_cancelButton" then
		
		hf.destroyOverlay()
		startcalc = false
		aStar.resetA_StarTables()
		while (glob.utilityMarker.bridgeMode.overlay[1] ~= nil) do
			glob.utilityMarker.bridgeMode.overlay[#glob.utilityMarker.bridgeMode.overlay].destroy()
			table.remove(glob.utilityMarker.bridgeMode.overlay)
		end
		bb_BridgeModeMenuFrame.destroy()
		um.utilitymarkerMainMenu()
	end

end

----------------------------------------------------------------------------------------------------------
-- function: 		calcTrack(startPos, endPos, isBridge)
-- description:		used to create railsroadtracks/bridges
-- parameter:		startPos; endPos; isBridge
-- return:			1 if succesful; 0 on failure
----------------------------------------------------------------------------------------------------------
function calcTrack(startPos, endPos, isBridge)
	
	hf.destroyOverlay()

	--[[local trackStart = {}
	trackStart.x = startPos.x - 0.5
	trackStart.y = startPos.y - 0.5
	if trackStart.x % 2 == 0 then
		trackStart.x = trackStart.x + 1
	end
	if trackStart.y % 2 == 0 then
		trackStart.y = trackStart.y + 1
	end]]

	--[[local trackEnd = {}
	trackEnd.x = endPos.x - 0.5
	trackEnd.y = endPos.y - 0.5

	if trackEnd.x % 2 == 0 then
		trackEnd.x = trackEnd.x + 1
	end
		
	if trackEnd.y % 2 == 0 then
		trackEnd.y = trackEnd.y + 1
	end]]



	local trackStart = {}
	trackStart.x = startPos.x
	trackStart.y = startPos.y
	local trackEnd = {}
	trackEnd.x = endPos.x
	trackEnd.y = endPos.y

	if glob.utilityMarker.marker[2].valid == true then glob.utilityMarker.marker[2].destroy() end
		if glob.utilityMarker.marker[1].valid == true then glob.utilityMarker.marker[1].destroy() end
		
	testPos = aStar.calcPath(startPos, endPos)
	while testPos.x ~= nil do
		startPos.x = testPos.x
		startPos.y = testPos.y
		game.createentity{name ="umOverlay", position = testPos,force=game.player.force}
		testPos = aStar.calcPath(startPos, endPos)
	end
			
	while #testPos > 0 do
		hf.createOverlay(testPos[#testPos], testPos[#testPos])
		table.remove(testPos)
	end

	game.player.print("done")
	return








--[[	if math.abs(trackStart.y - trackEnd.y) < 6 then
		--it has to be a horizontal line
		trackEnd.y = trackStart.y
		game.player.print("horizontal line")
	elseif (math.abs(trackStart.y - trackEnd.y) >= 6) and (math.abs(trackStart.y - trackEnd.y) < 10) then
		--it has to be a horizontal line with a shift
		game.player.print("horizontal line with shift")
	elseif math.abs(trackStart.y - trackEnd.y) >= 10 then
		--it has to be a horizontal curve
		game.player.print("curve")
	elseif math.abs(trackStart.x - trackEnd.x) < 6 then
		-- it has to be a vertical line
		trackEnd.x = trackStart.x
		game.player.print("vertical line")
	elseif (math.abs(trackStart.x - trackEnd.x) >= 6) and (math.abs(trackStart.x - trackEnd.x) < 10) then
		--it has to be a vertical line with a shift
		game.player.print("vertical line with shift")
	elseif math.abs(trackStart.x - trackEnd.x) >= 10 then
		--it has to be a vertical curve
		game.player.print("vertical curve")
	end

	local direction = getdirection(trackStart, trackEnd)
	
	while (getdirection(trackStart, trackEnd) ~= 8) do
		direction = getdirection(trackStart, trackEnd)
		local deltaPos = {x = 0, y = 0}
		local currentPos
		local destination
		local delta

		if direction == 0 then
			deltaPos = {x = 0, y = -2}
			currentPos = trackStart.y
			destination = trackEnd.y
			delta = -2
		elseif direction == 2 then
			deltaPos = {x = 2, y = 0}
			currentPos = trackStart.x
			destination = trackEnd.x
		delta = 2
		elseif direction == 4 then
			deltaPos = {x = 0, y = 2}
			currentPos = trackStart.y
			destination = trackEnd.y
			delta = 2
		elseif direction == 6 then
			deltaPos = {x = -2, y = 0}
			currentPos = trackStart.x
			destination = trackEnd.x
			delta = -2
		end
	
		if glob.utilityMarker.bridgeMode.rails == nil then
				glob.utilityMarker.bridgeMode.rails = {}
			glob.utilityMarker.bridgeMode.rails[1] = {}
			glob.utilityMarker.bridgeMode.rails[1].x = 0
			glob.utilityMarker.bridgeMode.rails[1].y = 0
			glob.utilityMarker.bridgeMode.rails[1].direction = 0
			glob.utilityMarker.bridgeMode.rails[1].type = "dummy"
		end
	
		while (math.abs(currentPos - destination) > 10) do -- enough space between start and (end or curve)
			glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {} 
			glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = trackStart.x
			glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = trackStart.y
			glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = direction
			glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "straight-rail"

			hf.createOverlay({x = trackStart.x - 0.5, y = trackStart.y - 0.5}, {x = trackStart.x + 0.5, y = trackStart.y + 0.5})
		
			trackStart.x = trackStart.x + deltaPos.x
			trackStart.y = trackStart.y + deltaPos.y
			currentPos = currentPos + delta
		end

		if math.abs(currentPos - destination) <= 10 then
			if (trackStart.x ~= trackEnd.x) and (trackStart.y ~= trackEnd.y) then -- we need a curve
				if trackStart.y < trackEnd.y then -- start is over end => curce down
					if trackStart.x < trackEnd.x then -- turn right
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {} 
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = trackStart.x + 3
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = trackStart.y + 1
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 3
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"

						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {} 
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = trackStart.x + 10
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = trackStart.y + 8
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 0
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"
					else -- turn left
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {} 
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = trackStart.x - 3
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = trackStart.y + 1
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 6
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"

						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {} 
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = trackStart.x - 8
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = trackStart.y + 8
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 1
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"
					end
					trackStart.y = trackStart.y + 12
					trackStart.x = trackStart.x + 5 * deltaPos.x
				elseif trackStart.y > trackEnd.y then -- start is under end
					if trackStart.x < trackEnd.x then -- turn left
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {} 
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = trackStart.x + 3
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = trackStart.y - 1
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 2
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"

						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {} 
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = trackStart.x + 10
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = trackStart.y - 6
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 5
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"
					else -- turn right
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {} 
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = trackStart.x - 3
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = trackStart.y - 1
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 7
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"

						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {} 
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = trackStart.x - 8
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = trackStart.y - 6
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 4
						glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"
					end
					trackStart.y = trackStart.y - 12
					trackStart.x = trackStart.x + 5 * deltaPos.x
				end
				
			else -- we are close to the end; insert last missing pieces
				while (currentPos ~= destination) do
					glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {} 
					glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = trackStart.x
					glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = trackStart.y
					glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = direction
					glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "straight-rail"
					hf.createOverlay({x = trackStart.x - 0.5, y = trackStart.y - 0.5}, {x = trackStart.x + 0.5, y = trackStart.y + 0.5})
					trackStart.x = trackStart.x + deltaPos.x
					trackStart.y = trackStart.y + deltaPos.y
					currentPos = currentPos + delta
				end
			end
		end

	end -- while (getdirection(trackStart, trackEnd) ~= 8) do




	if isBridge == true then

		if (startPos.y < (endPos.y - 8)) and (startPos.x < (endPos.x - 8)) then
			calcTrackTLBR(sPos, endPos, isBridge)
		elseif ((startPos.y - 8) > endPos.y) and ((startPos.x - 8) > endPos.x) then
			calcTrackTLBR(endPos, startPos, isBridge)
		end

	end]]

end

----------------------------------------------------------------------------------------------------------
-- function: 		buildTrack()
-- description:		used to build railsroadtracks/bridges in the onTick-event
-- parameter:		snone
-- return:			1 if finished; 0 if not done yet
----------------------------------------------------------------------------------------------------------
function buildTrack()
	if glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type ~= "dummy" then
		local pos = {}
		pos.x = glob.utilityMarker.bridgeMode.rails[2].x
		pos.y = glob.utilityMarker.bridgeMode.rails[2].y
		local dir = glob.utilityMarker.bridgeMode.rails[2].direction
		local typeOfRail = glob.utilityMarker.bridgeMode.rails[2].type

		if glob.utilityMarker.bridgeMode.railStorage.valid == false then return 0 end
		if glob.utilityMarker.bridgeMode.railStorage.getitemcount(typeOfRail) > 0 then
			game.createentity{name = typeOfRail, position = pos, force = game.player.force, direction = dir}
			glob.utilityMarker.bridgeMode.railStorage.getinventory(1).remove{name = typeOfRail, count = 1}

			table.remove(glob.utilityMarker.bridgeMode.rails,2)
		end

		return 0
	else
		return 1
	end
end

----------------------------------------------------------------------------------------------------------
-- function: 		discardRails()
-- description:		removed obsolete rail data from table
-- parameter:		none
-- return:			none
----------------------------------------------------------------------------------------------------------
function discardRails()
	if glob.utilityMarker.bridgeMode.rails == nil then return end

	while (#glob.utilityMarker.bridgeMode.rails ~= 1) do
		table.remove(glob.utilityMarker.bridgeMode.rails)
	end
end

----------------------------------------------------------------------------------------------------------
-- function: 		getDirection(startPos, endPos)
-- description:		used to determine in which directions the track will expand
-- parameter:		startPos; endPos
-- return:			0 = north
--					1 = northeast
--					2 = east
--					3 = southeast
--					4 = south
--					5 = southwest
--					6 = west
--					7 = northwest
--					8 = error
----------------------------------------------------------------------------------------------------------
function getDirection(startPos, endPos)

	if (startPos.x == endPos.x) and (startPos.y > endPos.y) then
		return 0 -- north
	elseif (startPos.x < endPos.x) and (startPos.y > endPos.y) then
		return 1 -- northeast
	elseif (startPos.x < endPos.x) and (startPos.y == endPos.y) then
		return 2 -- east
	elseif (startPos.x < endPos.x) and (startPos.y < endPos.y) then
		return 3 -- southeast
	elseif (startPos.x == endPos.x) and (startPos.y < endPos.y) then
		return 4 -- south
	elseif (startPos.x > endPos.x) and (startPos.y < endPos.y) then
		return 5 -- southwest
	elseif (startPos.x > endPos.x) and (startPos.y == endPos.y) then
		return 6 -- west
	elseif (startPos.x > endPos.x) and (startPos.y > endPos.y) then
		return 7 -- northwest
	else
		return 8 -- error
	end	
end

----------------------------------------------------------------------------------------------------------
-- function: 		calcTrackTLBR(startPos, endPos, isBridge)
-- description:		used to create railsroadtracks/bridges from top-left to bottom-right
-- parameter:		sPos; ePos; isBridge
-- return:			none
----------------------------------------------------------------------------------------------------------
function calcTrackTLBR(startPos, endPos, isBridge)

	local sPos = {x = startPos.x, y = startPos.y}
	local ePos = {x = endPos.x, y = endPos.y}

	if sPos.x < ePos.x then
		if (sPos.x - 0.5) % 2 == 0 then
			sPos.x = sPos.x + 1.5
		else
			sPos.x = sPos.x + 0.5
		end

		if (ePos.x - 0.5) % 2 == 0 then
			ePos.x = ePos.x - 0.5
		else
			ePos.x = ePos.x - 1.5
		end
	elseif sPos.x > ePos.x then
		if (sPos.x - 0.5) % 2 == 0 then
			sPos.x = sPos.x - 1.5
		else
			sPos.x = sPos.x - 2.5
		end

		if (ePos.x - 0.5) % 2 == 0 then
			ePos.x = ePos.x + 0.5
		else
			ePos.x = ePos.x + 1.5
		end
	end

	if (sPos.y - 0.5) % 2 == 0 then
		sPos.y = sPos.y + 0.5
	else
		sPos.y = sPos.y - 0.5
	end

	if (ePos.y - 0.5) % 2 == 0 then
		ePos.y = ePos.y - 1.5
	else
		ePos.y = ePos.y - 2.5
	end

	-- fit x coords
	while (util.distance(sPos, {x = ePos.x - 8, y = sPos.y}) > 2) do
		if glob.utilityMarker.bridgeMode.rails == nil then
			glob.utilityMarker.bridgeMode.rails = {}
			glob.utilityMarker.bridgeMode.rails[1] = {}
			glob.utilityMarker.bridgeMode.rails[1].x = 0
			glob.utilityMarker.bridgeMode.rails[1].y = 0
			glob.utilityMarker.bridgeMode.rails[1].direction = 0
			glob.utilityMarker.bridgeMode.rails[1].type = "dummy"
		end
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {}
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = sPos.x
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = sPos.y
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 2
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "straight-rail"
		hf.createOverlay({x = sPos.x, y = sPos.y - 1}, {x = sPos.x + 1, y = sPos.y})
		sPos.x = sPos.x + 2
	end
	-- place curve1 here
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {}
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = sPos.x + 5
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = sPos.y + 1
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 3
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"
	hf.createOverlay({x = sPos.x, y = sPos.y - 1}, {x = sPos.x + 1, y = sPos.y})
	hf.createOverlay({x = sPos.x + 2, y = sPos.y - 1}, {x = sPos.x + 3, y = sPos.y + 1})
	hf.createOverlay({x = sPos.x + 4, y = sPos.y}, {x = sPos.x + 5, y = sPos.y + 2 })
	hf.createOverlay({x = sPos.x + 6, y = sPos.y + 1}, {x = sPos.x + 7, y = sPos.y + 4 })
	hf.createOverlay({x = sPos.x + 8, y = sPos.y + 2}, {x = sPos.x + 8, y = sPos.y + 6 })
	hf.createOverlay({x = sPos.x + 9, y = sPos.y + 3}, {x = sPos.x + 9, y = sPos.y + 8 })
	hf.createOverlay({x = sPos.x + 10, y = sPos.y + 4}, {x = sPos.x + 10, y = sPos.y + 8 })
	hf.createOverlay({x = sPos.x + 11, y = sPos.y + 6}, {x = sPos.x + 11, y = sPos.y + 8 })
	-- fit y coords
	while (util.distance(ePos, {x = ePos.x, y = sPos.y + 8}) > 2) do
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {}
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = ePos.x
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = ePos.y
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 0
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "straight-rail"
		hf.createOverlay({x = ePos.x , y = ePos.y - 1}, {x = ePos.x + 1, y = ePos.y})
		ePos.y = ePos.y - 2
	end
	-- place curve2 here
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {}
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = ePos.x + 1
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = ePos.y - 3
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 0
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"
	hf.createOverlay({x = ePos.x , y = ePos.y - 1}, {x = ePos.x + 1, y = ePos.y})
	-- place diag part here
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {}
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = ePos.x - 4
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = ePos.y - 6
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 1
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "straight-rail"
end

----------------------------------------------------------------------------------------------------------
-- function: 		calcTrackBRTL(startPos, endPos, isBridge)
-- description:		used to create railsroadtracks/bridges from bottom-right to top-left
-- parameter:		sPos; ePos; isBridge
-- return:			none
----------------------------------------------------------------------------------------------------------
function calcTrackTLBR(startPos, endPos, isBridge)

	local sPos = {x = startPos.x, y = startPos.y}
	local ePos = {x = endPos.x, y = endPos.y}
	-- fit x coords
	while (util.distance(sPos, {x = ePos.x - 8, y = sPos.y}) > 2) do
		if glob.utilityMarker.bridgeMode.rails == nil then
			glob.utilityMarker.bridgeMode.rails = {}
			glob.utilityMarker.bridgeMode.rails[1] = {}
			glob.utilityMarker.bridgeMode.rails[1].x = 0
			glob.utilityMarker.bridgeMode.rails[1].y = 0
			glob.utilityMarker.bridgeMode.rails[1].direction = 0
			glob.utilityMarker.bridgeMode.rails[1].type = "dummy"
		end
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {}
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = sPos.x
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = sPos.y
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 2
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "straight-rail"
		hf.createOverlay({x = sPos.x, y = sPos.y - 1}, {x = sPos.x + 1, y = sPos.y})
		sPos.x = sPos.x + 2
	end
	-- place curve1 here
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {}
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = sPos.x + 5
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = sPos.y + 1
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 3
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"
	hf.createOverlay({x = sPos.x, y = sPos.y - 1}, {x = sPos.x + 1, y = sPos.y})
	hf.createOverlay({x = sPos.x + 2, y = sPos.y - 1}, {x = sPos.x + 3, y = sPos.y + 1})
	hf.createOverlay({x = sPos.x + 4, y = sPos.y}, {x = sPos.x + 5, y = sPos.y + 2 })
	hf.createOverlay({x = sPos.x + 6, y = sPos.y + 1}, {x = sPos.x + 7, y = sPos.y + 4 })
	hf.createOverlay({x = sPos.x + 8, y = sPos.y + 2}, {x = sPos.x + 8, y = sPos.y + 6 })
	hf.createOverlay({x = sPos.x + 9, y = sPos.y + 3}, {x = sPos.x + 9, y = sPos.y + 8 })
	hf.createOverlay({x = sPos.x + 10, y = sPos.y + 4}, {x = sPos.x + 10, y = sPos.y + 8 })
	hf.createOverlay({x = sPos.x + 11, y = sPos.y + 6}, {x = sPos.x + 11, y = sPos.y + 8 })
	-- fit y coords
	while (util.distance(ePos, {x = ePos.x, y = sPos.y + 8}) > 2) do
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {}
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = ePos.x
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = ePos.y
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 0
		glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "straight-rail"
		hf.createOverlay({x = ePos.x , y = ePos.y - 1}, {x = ePos.x + 1, y = ePos.y})
		ePos.y = ePos.y - 2
	end
	-- place curve2 here
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {}
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = ePos.x + 1
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = ePos.y - 3
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 0
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "curved-rail"
	hf.createOverlay({x = ePos.x , y = ePos.y - 1}, {x = ePos.x + 1, y = ePos.y})
	-- place diag part here
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails + 1] = {}
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].x = ePos.x - 4
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].y = ePos.y - 6
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].direction = 1
	glob.utilityMarker.bridgeMode.rails[#glob.utilityMarker.bridgeMode.rails].type = "straight-rail"
end