module(..., package.seeall)


----------------------------------------------------------------------------------------------------------
-- function: 		onUtilityMarkerBuilt(markerEntity)
-- description:		called after an UM was placed; calculates the minPos/maxPos; sets an in use flag  
-- parameter:		markerentity
-- return:			none
----------------------------------------------------------------------------------------------------------
function onUtilityMarkerBuilt(markerEntity)
	glob.utilityMarker.count = glob.utilityMarker.count + 1
	if glob.utilityMarker.count <= 2 then
		glob.utilityMarker.marker[glob.utilityMarker.count] = markerEntity		
		if (glob.utilityMarker.count == 2) then
			glob.utilityMarker.markerUsed = true
			glob.utilityMarker.minPos.x = math.min ( glob.utilityMarker.marker[1].position.x , glob.utilityMarker.marker[2].position.x)
			glob.utilityMarker.minPos.y = math.min ( glob.utilityMarker.marker[1].position.y , glob.utilityMarker.marker[2].position.y)
			glob.utilityMarker.maxPos.x = math.max ( glob.utilityMarker.marker[1].position.x , glob.utilityMarker.marker[2].position.x)
			glob.utilityMarker.maxPos.y = math.max ( glob.utilityMarker.marker[1].position.y , glob.utilityMarker.marker[2].position.y)
			glob.utilityMarker.area = (glob.utilityMarker.maxPos.x - glob.utilityMarker.minPos.x + 1) * (glob.utilityMarker.maxPos.y - glob.utilityMarker.minPos.y + 1)
			glob.utilityMarker.area_x = (glob.utilityMarker.maxPos.x - glob.utilityMarker.minPos.x + 1)
			glob.utilityMarker.area_y = (glob.utilityMarker.maxPos.y - glob.utilityMarker.minPos.y + 1)
			utilitymarkerMainMenu()
		end
	end
end

----------------------------------------------------------------------------------------------------------
-- function: 		utilitymarkerMainMenu()
-- description:		creates the Main Menu
-- parameter:		none
-- return:			none
----------------------------------------------------------------------------------------------------------
function utilitymarkerMainMenu()
		um_utilityMarkerMainMenuFrame = game.player.gui.top.add{type="frame", name="um_utilityMarkerMainMenuFrame", caption="Select Function", direction="vertical"}

		um_utilityMarkerMainMenuFrame.add{type="button", name="um_bridgeButton", caption="Build Bridge"}

		um_utilityMarkerMainMenuFrame.add{type="button", name="um_closeMainMenuButton", caption="Cancel"}
end

----------------------------------------------------------------------------------------------------------
-- function: 		mainMenuButtonClicked(buttonName)
-- description:		used to determine which main menu button was clicked  
-- parameter:		buttonName
-- return:			none
----------------------------------------------------------------------------------------------------------
function mainMenuButtonClicked(buttonName)
	if buttonName == "um_bridgeButton" then
		bb.initBridgeMode()
	elseif buttonName == "um_closeMainMenuButton" then
		game.player.gui.top.um_utilityMarkerMainMenuFrame.destroy()
		if glob.utilityMarker.marker[2].valid == true then glob.utilityMarker.marker[2].destroy() end
		if glob.utilityMarker.marker[1].valid == true then glob.utilityMarker.marker[1].destroy() end
		glob.utilityMarker.count = 0
		glob.utilityMarker.markerUsed = false
		game.player.character.insert{name="utilitymarker-2", count = 2}
	end
end










--[[function removeEntities()
	local entities = {}
	local finished = true
	
	if (glob.blueprints.clearmode.mode == "trees") then
		entities = game.findentitiesfiltered{area = {glob.blueprints.utilitymarker.minPos, glob.blueprints.utilitymarker.maxPos}, type="tree"}
		for _, entity in ipairs(entities) do
			hf.create_smoke(entity.position)
			table.insert(glob.blueprints.clearmode.name, "raw-wood")
			finished = false				
			entity.destroy()
			break
		end -- _, entity in ipairs(entities) do
	elseif (glob.blueprints.clearmode.mode == "structures") then
		local save = true
		entities = game.findentities{glob.blueprints.utilitymarker.minPos, glob.blueprints.utilitymarker.maxPos}
		for _, entity in ipairs(entities) do
			if (entity.type == "train-stop") then
				hf.create_smoke(entity.position)
				table.insert(glob.blueprints.clearmode.name, entity.name)				
				entity.destroy()
				save = false
				break
			elseif  (entity.type == "rail-signal") then
				hf.create_smoke(entity.position)
				table.insert(glob.blueprints.clearmode.name, entity.name)				
				entity.destroy()
				save = false
				break
			elseif (entity.type == "cargo-wagon") then
				hf.create_smoke(entity.position)
				table.insert(glob.blueprints.clearmode.name, entity.name)				
				entity.destroy()
				save = false
				break
			elseif (entity.type == "locomotive") then
				hf.create_smoke(entity.position)
				table.insert(glob.blueprints.clearmode.name, entity.name)				
				entity.destroy()
				save = false
				break
			elseif (entity.name== "minefieldedge") then
				hf.create_smoke(entity.position)				
				entity.destroy()
				save = false
				break
			elseif (entity.name== "miningsiteedge") then
				hf.create_smoke(entity.position)				
				entity.destroy()
				save = false
				break
			elseif (entity.name== "utilitymarker") then
				hf.create_smoke(entity.position)				
				entity.destroy()
				save = false
				break
			elseif (entity.name== "bpOverlay") then
				hf.create_smoke(entity.position)				
				entity.destroy()
				save = false
				break
			end
		end --  _, entity in ipairs(entities)
		finished = true
		if save == true then
			entities = game.findentities{glob.blueprints.utilitymarker.minPos, glob.blueprints.utilitymarker.maxPos}
			for _, entity in ipairs(entities) do
				finished = true
				if (entity.hasflag("player-creation")) and not (entity.force.equals(game.forces.enemy)) then
					hf.create_smoke(entity.position)
					table.insert(glob.blueprints.clearmode.name, entity.name)
					finished = false				
					entity.destroy()
					break
				end
			end -- _, entity in ipairs(entities) do
		else
			finished = false
		end
	end -- (glob.blueprints.clearmode.mode == "trees") elseif (glob.blueprints.clearmode.mode == "structures") then	

	if finished == true then				
		local actual_chest = game.createentity{name = "wooden-chest", position = glob.blueprints.utilitymarker.minPos, force=game.player.force}
		for k,_ in ipairs(glob.blueprints.clearmode.name) do
			if actual_chest.caninsert{name = glob.blueprints.clearmode.name[k], count = 1} then
				actual_chest.insert{name = glob.blueprints.clearmode.name[k], count = 1}
			else
				if glob.blueprints.utilitymarker.minPos.x < glob.blueprints.utilitymarker.maxPos.x then
					glob.blueprints.utilitymarker.minPos.x = glob.blueprints.utilitymarker.maxPos.x + 1
				else
					glob.blueprints.utilitymarker.minPos.y = glob.blueprints.utilitymarker.maxPos.y + 1
				end
				actual_chest = game.createentity{name = "wooden-chest", position = glob.blueprints.utilitymarker.minPos, force=game.player.force}
				actual_chest.insert{name = glob.blueprints.clearmode.name[k], count = 1}
			end
		end -- k,_ in ipairs(glob.blueprints.clearmode.name) do

		game.player.print("Area cleared!")
		local rnd = math.floor(((math.random() * 15 + 75) / 100) * glob.blueprints.utilitymarker.nanobots)  -- give the player 75-90% of the nanobots back
		game.getplayer().character.insert{name = "nanobots", count = rnd}
		game.player.print("You received:"..rnd.. " of " ..glob.blueprints.utilitymarker.nanobots.. " Nanobots back")
		while (glob.blueprints.clearmode.name[1] ~= nil) do
			table.remove(glob.blueprints.clearmode.name)
		end
		glob.blueprints.clearmode.runflag = false
		glob.blueprints.utilitymarker.area = 0
		glob.blueprints.utilitymarker.area_x = 0
		glob.blueprints.utilitymarker.area_y = 0
		glob.blueprints.utilitymarker.count = 0
		glob.blueprints.utilitymarker.nanobots = 0
		glob.blueprints.markerUsed = false
		hf.destroyOverlay()
		if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
		if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
		game.player.character.insert{name="utilitymarker", count = 2}
	end -- finished == true
end--]]

--[[function createMinefield()
	glob.blueprints.minefields.count = glob.blueprints.minefields.count + 1
	glob.blueprints.minefields[glob.blueprints.minefields.count] = {}
	glob.blueprints.minefields[glob.blueprints.minefields.count][1] = game.createentity{name="minefieldedge", position = glob.blueprints.utilitymarker.minPos, force=game.player.force}
	glob.blueprints.minefields[glob.blueprints.minefields.count][2] = game.createentity{name="minefieldedge", position = {glob.blueprints.utilitymarker.maxPos.x, glob.blueprints.utilitymarker.minPos.y}, force=game.player.force}
	glob.blueprints.minefields[glob.blueprints.minefields.count][3] = game.createentity{name="minefieldedge", position = glob.blueprints.utilitymarker.maxPos, force=game.player.force}
	glob.blueprints.minefields[glob.blueprints.minefields.count][4] = game.createentity{name="minefieldedge", position = {glob.blueprints.utilitymarker.minPos.x, glob.blueprints.utilitymarker.maxPos.y}, force=game.player.force}
	glob.blueprints.minefields[glob.blueprints.minefields.count].valid = true
	glob.blueprints.minefields[glob.blueprints.minefields.count].minPos = glob.blueprints.minefields[glob.blueprints.minefields.count][1].position
	glob.blueprints.minefields[glob.blueprints.minefields.count].maxPos = glob.blueprints.minefields[glob.blueprints.minefields.count][3].position
end]]


--[[function maintainMinefield(currentMinefield)
	local edge = 0
	for i = 1, 4 do
		if glob.blueprints.minefields[currentMinefield][i].valid then
			edge = edge + 1
		end
	end

	if edge == 0 then
		glob.blueprints.minefields[currentMinefield].valid = false
		glob.blueprints.minefields.needCleanUp = true
		return
	end

	
	for i = 1, 4 do
		if glob.blueprints.minefields[currentMinefield][i].valid then
			if glob.blueprints.minefields[currentMinefield][i].getitemcount("land-mine") > 0 then
				for x = glob.blueprints.minefields[currentMinefield].minPos.x + 1, glob.blueprints.minefields[currentMinefield].maxPos.x - 1 do
					for y = glob.blueprints.minefields[currentMinefield].minPos.y + 1, glob.blueprints.minefields[currentMinefield].maxPos.y - 1 do
						if game.canplaceentity{name = "land-mine", position = {x, y}} then
							glob.blueprints.minefields[currentMinefield][i].getinventory(1).remove{name = "land-mine", count = 1}
							game.createentity{name="land-mine", position = {x,y}, force = game.player.force}
							return
						end
					end
				end
			end
		end
	end
end]]


--[[function removeMinefield()	
	for k,_ in ipairs (glob.blueprints.minefields) do
		if glob.blueprints.minefields[k].valid == false then
			table.remove(glob.blueprints.minefields,k)
			glob.blueprints.minefields.count = glob.blueprints.minefields.count - 1
			return
		end		
	end
	glob.blueprints.minefields.needCleanUp = false
end]]


--[[function createMiningsite()
	glob.blueprints.miningsites.count = glob.blueprints.miningsites.count + 1
	glob.blueprints.miningsites[glob.blueprints.miningsites.count] = {}
	glob.blueprints.miningsites[glob.blueprints.miningsites.count][1] = game.createentity{name="miningsiteedge", position = glob.blueprints.utilitymarker.minPos, force=game.player.force}
	glob.blueprints.miningsites[glob.blueprints.miningsites.count][2] = game.createentity{name="miningsiteedge", position = {glob.blueprints.utilitymarker.maxPos.x, glob.blueprints.utilitymarker.minPos.y}, force=game.player.force}
	glob.blueprints.miningsites[glob.blueprints.miningsites.count][3] = game.createentity{name="miningsiteedge", position = glob.blueprints.utilitymarker.maxPos, force=game.player.force}
	glob.blueprints.miningsites[glob.blueprints.miningsites.count][4] = game.createentity{name="miningsiteedge", position = {glob.blueprints.utilitymarker.minPos.x, glob.blueprints.utilitymarker.maxPos.y}, force=game.player.force}
	glob.blueprints.miningsites[glob.blueprints.miningsites.count].valid = true
	glob.blueprints.miningsites[glob.blueprints.miningsites.count].minPos = glob.blueprints.miningsites[glob.blueprints.miningsites.count][1].position
	glob.blueprints.miningsites[glob.blueprints.miningsites.count].maxPos = glob.blueprints.miningsites[glob.blueprints.miningsites.count][3].position
	if game.player.gui.top.utilitymarkerMiningsiteFrame.MiningsiteNameText.text ~= "" then
		glob.blueprints.miningsites[glob.blueprints.miningsites.count].MiningsiteName = game.player.gui.top.utilitymarkerMiningsiteFrame.MiningsiteNameText.text
	else
		glob.blueprints.miningsites[glob.blueprints.miningsites.count].MiningsiteName = "Miningsite " ..glob.blueprints.miningsites.count
	end
	glob.blueprints.miningsites[glob.blueprints.miningsites.count].depleated = false
	glob.blueprints.miningsites[glob.blueprints.miningsites.count].showInUI = true
end]]


--[[function checkOreAmount(minPos, maxPos)
	local amount = 0
	local oreDeposits = game.findentitiesfiltered{area = {minPos, maxPos}, type="resource"}
	for k,_ in ipairs(oreDeposits) do
		amount = amount + oreDeposits[k].amount
	end
	return amount
end]]


--[[function maintainMiningsite(currentMiningsite)
	
	local edge = 0
	local space = 0
	local nanobotsAmount = 0
	local nanobotsDestroyed = 0

	for i = 1, 4 do
		if glob.blueprints.miningsites[currentMiningsite][i].valid then
			edge = edge + 1
		end
	end

	if edge == 0 then
		glob.blueprints.miningsites[currentMiningsite].valid = false
		glob.blueprints.miningsites.needCleanUp = true
		return
	end

	
	for i = 1, 4 do
		if glob.blueprints.miningsites[currentMiningsite][i].valid == true then
			nanobotsAmount = nanobotsAmount + glob.blueprints.miningsites[currentMiningsite][i].getitemcount("nanobots")
		end
	end


	nanobotsDestroyed = math.floor(nanobotsAmount * 0.001 + (math.random()))

	if glob.blueprints.miningsites[currentMiningsite].depleated == false then
		for i = 1, 4 do
			if nanobotsDestroyed <= 0 then break end
			if glob.blueprints.miningsites[currentMiningsite][i].valid == true then
				local tempNanobotsAmount = glob.blueprints.miningsites[currentMiningsite][i].getitemcount("nanobots")
				if tempNanobotsAmount >= nanobotsDestroyed then
					glob.blueprints.miningsites[currentMiningsite][i].getinventory(1).remove{name = "nanobots", count = nanobotsDestroyed}
					break
				elseif tempNanobotsAmount > 0 then
					glob.blueprints.miningsites[currentMiningsite][i].getinventory(1).remove{name = "nanobots", count = tempNanobotsAmount}
					nanobotsDestroyed = nanobotsDestroyed - tempNanobotsAmount
				end
			end
		end
	end






	if checkOreAmount(glob.blueprints.miningsites[currentMiningsite].minPos, glob.blueprints.miningsites[currentMiningsite].maxPos) > 0 then
		if nanobotsAmount > 0 then
			local oreDeposits = game.findentitiesfiltered{area = {glob.blueprints.miningsites[currentMiningsite].minPos, glob.blueprints.miningsites[currentMiningsite].maxPos}, type="resource"}
			local nanobotsMultiplier = nanobotsAmount / #oreDeposits
			if nanobotsMultiplier > 10000 then 
				nanobotsMultiplier = 10000 
			elseif nanobotsMultiplier < 1 then
				nanobotsMultiplier = 1
			end
			local minedItems = math.ceil(#oreDeposits * 0.0148 * nanobotsMultiplier) 
			for _, resource in ipairs(oreDeposits) do
				for i = 1, 4 do
					if glob.blueprints.miningsites[currentMiningsite][i].valid == true then
						if (glob.blueprints.miningsites[currentMiningsite][i].caninsert{name = resource.name, count = minedItems}) == true then
  							if resource.amount - minedItems <= 0 then
  								resource.destroy()
  							else
  								resource.amount = resource.amount - minedItems
  								glob.blueprints.miningsites[currentMiningsite][i].insert{name = resource.name, count = minedItems}
  							end
  							return
						else
							space = space + 1
						end
					end
				end
				if space == 4 then return end
			end
		else
			return
		end
	end

	if glob.blueprints.miningsites[currentMiningsite].depleated == false then
		game.player.print(glob.blueprints.miningsites[currentMiningsite].MiningsiteName.. " is depleated! Empty the storage.")
		glob.blueprints.miningsites[currentMiningsite].depleated = true
	end
	for i = 1, 4 do
		if glob.blueprints.miningsites[currentMiningsite][i].valid == true then
			if glob.blueprints.miningsites[currentMiningsite][i].getinventory(1).isempty() == true then
				glob.blueprints.miningsites[currentMiningsite][i].destroy()
			end
		end
	end


end -- maintainMiningsite(currentMiningsite)]]


--[[function removeMiningsite()
	for k,_ in ipairs (glob.blueprints.miningsites) do
		if glob.blueprints.miningsites[k].valid == false then
			table.remove(glob.blueprints.miningsites,k)
			glob.blueprints.miningsites.count = glob.blueprints.miningsites.count - 1
			return
		end		
	end
	glob.blueprints.miningsites.needCleanUp = false
end]]


--[[function createMiningsiteOverseer()
	glob.blueprints.overseer.count = glob.blueprints.overseer.count + 1
	glob.blueprints.overseer[glob.blueprints.overseer.count] = {}
	glob.blueprints.overseer[glob.blueprints.overseer.count][1] = game.createentity{name="miningsiteedge2", position = glob.blueprints.utilitymarker.minPos, force=game.player.force}
	glob.blueprints.overseer[glob.blueprints.overseer.count][2] = game.createentity{name="miningsiteedge2", position = {glob.blueprints.utilitymarker.maxPos.x, glob.blueprints.utilitymarker.minPos.y}, force=game.player.force}
	glob.blueprints.overseer[glob.blueprints.overseer.count][3] = game.createentity{name="miningsiteedge2", position = glob.blueprints.utilitymarker.maxPos, force=game.player.force}
	glob.blueprints.overseer[glob.blueprints.overseer.count][4] = game.createentity{name="miningsiteedge2", position = {glob.blueprints.utilitymarker.minPos.x, glob.blueprints.utilitymarker.maxPos.y}, force=game.player.force}
	glob.blueprints.overseer[glob.blueprints.overseer.count].valid = true
	glob.blueprints.overseer[glob.blueprints.overseer.count].minPos = glob.blueprints.overseer[glob.blueprints.overseer.count][1].position
	glob.blueprints.overseer[glob.blueprints.overseer.count].maxPos = glob.blueprints.overseer[glob.blueprints.overseer.count][3].position
	if game.player.gui.top.utilitymarkerMiningsiteOverseerFrame.MiningsiteOverseerNameText.text ~= "" then
		glob.blueprints.overseer[glob.blueprints.overseer.count].MiningsiteName = game.player.gui.top.utilitymarkerMiningsiteOverseerFrame.MiningsiteOverseerNameText.text
	else
		glob.blueprints.overseer[glob.blueprints.overseer.count].MiningsiteName = "Overseer " ..glob.blueprints.overseer.count
	end
end]]


--[[function maintainOverseer(currentOverseer)
	
	local edge = 0

	for i = 1, 4 do
		if glob.blueprints.overseer[currentOverseer][i].valid then
			edge = edge + 1
		end
	end

	if edge == 0 then
		glob.blueprints.overseer[currentOverseer].valid = false
		glob.blueprints.overseer.needCleanUp = true
		return
	end

end -- maintainOverseer(currentOverseer)]]


--[[function removeOverseer()
	for k,_ in ipairs (glob.blueprints.overseer) do
		if glob.blueprints.overseer[k].valid == false then
			for i,_ in ipairs (glob.blueprints.overseer[k]) do
				if glob.blueprints.overseer[k][i].valid then glob.blueprints.overseer[k][i].destroy() end
			end
			table.remove(glob.blueprints.overseer,k)
			glob.blueprints.overseer.count = glob.blueprints.overseer.count - 1
			return
		end		
	end
	glob.blueprints.overseer.needCleanUp = false
end]]

--------------------BUTTON FUNCTIONS--------------------------------------


--[[function utilitymarkerButtonClicked(buttonName)

	if buttonName == "UMM_utilitymarkerModeRemoveTreesButton" then
		glob.blueprints.clearmode.mode = "trees"
		local k = 1
		local entities = {}
		entities = game.findentitiesfiltered{area = {glob.blueprints.utilitymarker.minPos, glob.blueprints.utilitymarker.maxPos}, type="tree"}
		for _, entity in ipairs(entities) do
			k = k + 1
		end
		if k > 1 then
			glob.blueprints.clearmode.count = k - 1
			glob.blueprints.utilitymarker.nanobots = glob.blueprints.utilitymarker.area + (k - 1)
			UI.clearmarker_UI_creation()
		else
			glob.blueprints.clearmode.runflag = false
			glob.blueprints.utilitymarker.count = 0
			game.player.print("No entity selected! Try again.")
			if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
			if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
			game.player.character.insert{name="utilitymarker", count = 2}
			glob.blueprints.markerUsed = false
			hf.destroyOverlay()
		end
		game.player.gui.top.bp_utilitymarkerModeFrame.destroy()
	
	elseif buttonName == "UMM_utilitymarkerModeRemoveStructuresButton" then
		glob.blueprints.clearmode.mode = "structures"
		local k = 1
		local entities = {}
		entities = game.findentities{glob.blueprints.utilitymarker.minPos, glob.blueprints.utilitymarker.maxPos}			
		for _, entity in ipairs(entities) do 	-- stores the needed entity information that are in the selected area
			if (entity.hasflag("player-creation")) and not (entity.force.equals(game.forces.enemy)) and (entity.name ~= "player")
				and (entity.type ~= "item-entity") and (entity.name ~= "utilitymarker") and (entity.name ~= "bpOverlay") then
					k = k + 1
			end -- (entity.hasflag("player-creation")) and not (entity.force.equals(game.forces.enemy)) and ... then
		end -- _, entity in ipairs(entities)
		if k > 1 then
			glob.blueprints.clearmode.count = k - 1
			glob.blueprints.utilitymarker.nanobots = glob.blueprints.utilitymarker.area + (k - 1)
			UI.clearmarker_UI_creation()
		else
			glob.blueprints.clearmode.runflag = false
			glob.blueprints.utilitymarker.count = 0
			game.player.print("No entity selected! Try again.")
			if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
			if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
			game.player.character.insert{name="utilitymarker", count = 2}
			glob.blueprints.markerUsed = false
			hf.destroyOverlay()
		end
		game.player.gui.top.bp_utilitymarkerModeFrame.destroy()
	
	elseif buttonName == "UMM_utilitymarkerModeMinefieldButton" then
		game.player.gui.top.bp_utilitymarkerModeFrame.destroy()
		UI.minefield_UI_creation()
	elseif buttonName == "UMM_utilitymarkerModeMiningsiteButton" then	
		if checkOreAmount(glob.blueprints.utilitymarker.minPos, glob.blueprints.utilitymarker.maxPos) > 0 then 
			game.player.gui.top.bp_utilitymarkerModeFrame.destroy()
			UI.miningsite_UI_creation()
		else
			game.player.print("There are no ressources in the selected area! Try again!")
			game.player.gui.top.bp_utilitymarkerModeFrame.destroy()
			hf.destroyOverlay()
			glob.blueprints.utilitymarker.count = 0
			if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
			if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
			game.player.character.insert{name="utilitymarker", count = 2}
			glob.blueprints.markerUsed = false
		end

	elseif buttonName == "UMM_utilitymarkerModeRepairstationButton" then


	elseif buttonName == "UMM_utilitymarkerModeMiningOverseerButton" then
		if checkOreAmount(glob.blueprints.utilitymarker.minPos, glob.blueprints.utilitymarker.maxPos) > 0 then 
			game.player.gui.top.bp_utilitymarkerModeFrame.destroy()
			UI.addMiningsiteOverseer_UI_creation()
		else
			game.player.print("There are no ressources in the selected area! Try again!")
			game.player.gui.top.bp_utilitymarkerModeFrame.destroy()
			hf.destroyOverlay()
			glob.blueprints.utilitymarker.count = 0
			if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
			if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
			game.player.character.insert{name="utilitymarker", count = 2}
			glob.blueprints.markerUsed = false
		end
	elseif buttonName == "UMM_utilitymarkerShowOverseerButton" then
		glob.blueprints.overseer.closed = false
		game.player.gui.top.bp_utilitymarkerModeFrame.destroy()
		UI.miningsiteOverseer_UI_creation()
		hf.destroyOverlay()
		glob.blueprints.utilitymarker.count = 0
		if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
		if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
		game.player.character.insert{name="utilitymarker", count = 2}
		glob.blueprints.markerUsed = false
	elseif buttonName == "UMM_utilitymarkerModeCancelButton" then
		game.player.gui.top.bp_utilitymarkerModeFrame.destroy()
		hf.destroyOverlay()
		glob.blueprints.utilitymarker.count = 0
		if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
		if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
		game.player.character.insert{name="utilitymarker", count = 2}
		glob.blueprints.markerUsed = false
	end
end]]


--[[function utilityModeButtonClicked(buttonName)
	if buttonName == "UMT_removeYes_Button" then
		if ((game.getplayer().character.getinventory(1).getitemcount("nanobots") + game.getplayer().character.getinventory(2).getitemcount("nanobots")) >= glob.blueprints.utilitymarker.nanobots) then 				
			game.player.gui.top.bp_blueprint_clear_frame.destroy()
			glob.blueprints.clearmode.runflag = true
			hf.remove_nanobots("clear")
		else
			game.player.print("You do not have enough nanobots in your inv!")
		end
		hf.destroyOverlay()
	elseif buttonName == "UMT_removeCancelButton" then
		game.player.gui.top.bp_blueprint_clear_frame.destroy()
		hf.destroyOverlay()
		glob.blueprints.clearmode.runflag = false
		glob.blueprints.utilitymarker.area = 0
		glob.blueprints.utilitymarker.area_x = 0
		glob.blueprints.utilitymarker.area_y = 0
		glob.blueprints.utilitymarker.count = 0
		glob.blueprints.clearmode.count = 0
		glob.blueprints.utilitymarker.nanobots = 0
		glob.blueprints.markerUsed = false
		if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
		if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
		game.player.character.insert{name="utilitymarker", count = 2}
	elseif buttonName == "UMT_MinefieldCreateButton" then
		createMinefield()
		game.player.gui.top.utilitymarkerMinefieldFrame.destroy()
		hf.destroyOverlay()
		if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
		if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
		game.player.character.insert{name="utilitymarker", count = 2}

		glob.blueprints.utilitymarker.area = 0
		glob.blueprints.utilitymarker.area_x = 0
		glob.blueprints.utilitymarker.area_y = 0
		glob.blueprints.utilitymarker.count = 0
		glob.blueprints.markerUsed = false
	elseif buttonName == "UMT_MinefieldCancelButton" then
		game.player.gui.top.utilitymarkerMinefieldFrame.destroy()
		hf.destroyOverlay()
		glob.blueprints.utilitymarker.count = 0
		if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
		if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
		game.player.character.insert{name="utilitymarker", count = 2}
		glob.blueprints.markerUsed = false
	elseif buttonName == "UMT_MiningsiteCreateButton" then
		createMiningsite()
		game.player.gui.top.utilitymarkerMiningsiteFrame.destroy()
		hf.destroyOverlay()
		if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
		if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
		game.player.character.insert{name="utilitymarker", count = 2}

		glob.blueprints.utilitymarker.area = 0
		glob.blueprints.utilitymarker.area_x = 0
		glob.blueprints.utilitymarker.area_y = 0
		glob.blueprints.utilitymarker.count = 0
		glob.blueprints.markerUsed = false

	elseif buttonName == "UMT_MiningsiteCancelButton" then
		game.player.gui.top.utilitymarkerMiningsiteFrame.destroy()
		hf.destroyOverlay()
		glob.blueprints.utilitymarker.count = 0
		if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
		if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
		game.player.character.insert{name="utilitymarker", count = 2}
		glob.blueprints.markerUsed = false



	elseif buttonName == "UMT_MiningsiteOverseerCreateButton" then
		createMiningsiteOverseer()
		game.player.gui.top.utilitymarkerMiningsiteOverseerFrame.destroy()
		hf.destroyOverlay()
		if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
		if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
		game.player.character.insert{name="utilitymarker", count = 2}

		glob.blueprints.utilitymarker.area = 0
		glob.blueprints.utilitymarker.area_x = 0
		glob.blueprints.utilitymarker.area_y = 0
		glob.blueprints.utilitymarker.count = 0
		glob.blueprints.markerUsed = false
	elseif buttonName == "UMT_MiningsiteOverseerCancelButton" then
		game.player.gui.top.utilitymarkerMiningsiteOverseerFrame.destroy()
		hf.destroyOverlay()
		glob.blueprints.utilitymarker.count = 0
		if glob.blueprints.utilitymarker[1].valid then glob.blueprints.utilitymarker[1].destroy() end
		if glob.blueprints.utilitymarker[2].valid then glob.blueprints.utilitymarker[2].destroy() end
		game.player.character.insert{name="utilitymarker", count = 2}
		glob.blueprints.markerUsed = false
	end
end]]


--[[function overseerButtonClicked(buttonName)
	
	if buttonName == "UMO_OverseerCloseButton" then
		game.player.gui.top.miningsiteOverseerFrame.destroy()
		glob.blueprints.overseer.closed = true
	elseif buttonName == "UMO_OverseerMinimizeButton" then
		if glob.blueprints.overseer.minimized == true then
			glob.blueprints.overseer.minimized = false
		else
			glob.blueprints.overseer.minimized = true
		end
		if game.player.gui.top.miningsiteOverseerFrame ~= nil then game.player.gui.top.miningsiteOverseerFrame.destroy() end
		UI.miningsiteOverseer_UI_creation()
	elseif buttonName == "UMO_OverseerAddButton" then		
		local showUI = false
		for i = 1, glob.blueprints.miningsites.count do
			if glob.blueprints.miningsites[i].showInUI == false then
				showUI = true
				break
			end
		end
		if (showUI == true) and (game.player.gui.top.miningsiteOverseerAddFrame == nil) then
			UI.miningsiteOverseer_AddUI()
		elseif showUI == false then
			game.player.print("There is nothing you can add")
		end

	elseif string.sub(buttonName,5,5) == "O" then
		glob.blueprints.overseer[tonumber(string.sub(buttonName,6))].valid = false
		glob.blueprints.overseer.needCleanUp = true
		while glob.blueprints.overseer.needCleanUp == true do um.removeOverseer() end
		game.player.gui.top.miningsiteOverseerFrame.destroy()
		UI.miningsiteOverseer_UI_creation()
	elseif string.sub(buttonName,5,5) == "M" then
		glob.blueprints.miningsites[tonumber(string.sub(buttonName,6))].showInUI = false
		game.player.gui.top.miningsiteOverseerFrame.destroy()
		UI.miningsiteOverseer_UI_creation()
	elseif string.sub(buttonName,5,5) == "A" then
		glob.blueprints.miningsites[tonumber(string.sub(buttonName,6))].showInUI = true
		game.player.gui.top.miningsiteOverseerAddFrame.destroy()
		game.player.gui.top.miningsiteOverseerFrame.destroy()
		UI.miningsiteOverseer_UI_creation()		
	end
end]]